mui.init();
var vm;
var elemForm = ["customer_phone", "receiver_phone"];

light.plusready(function() {
	loadPage();
});

function loadPage() {
	plus.screen.lockOrientation("portrait-primary"); //锁定竖屏，避免原生返回变横屏
	avalonInit();
	mui(".mui-input-row").on('tap', '.mui-icon-clear', function() { //捕获清空按钮事件,主动重置avalon变量
		var o = event.currentTarget.children;
		for (var i in o) {
			if (o[i].tagName == "INPUT" && o[i].id) {
				vm[o[i].id] = "";
				break;
			}
		}
	});
}

function topRightFun() {
	checkForm();
}

function avalonInit() {
	vm = avalon.define({
		$id: "avaCtl",
		submitState: "生成二维码",
		qrCode: "",
		customer_phone: "",
		receiver_phone: ""
	});
	avalon.scan();
}

function setPhone(customer_phone, receiver_phone) {
	if (vm) {
		vm.customer_phone = customer_phone;
		vm.receiver_phone = receiver_phone;
		autoQRCode(); //自动生成二维码
	} else {
		setTimeout(function() {
			setPhone(customer_phone, receiver_phone);
		}, 1000);
	}
}
var lenCheck = [{
	name: "customer_phone",
	title: "寄件人电话",
	len: 20,
	notNull: true
}, {
	name: "receiver_phone",
	title: "收件人电话",
	len: 50
}];

function checkForm() { //检查表单内容及快递单号是否重复	
	vm.submitState = "生成中...";
	for (var i in elemForm) { //清理首尾空格
		vm[elemForm[i]] = light.trim(vm[elemForm[i]]);
	}
	for (var i in lenCheck) { //检查填写规范
		if (lenCheck[i].notNull != null && lenCheck[i].notNull && vm[lenCheck[i].name].length == 0) {
			return showMsg("请输入“" + lenCheck[i].title + "”");
		}
		if (lenCheck[i].fitLen != null && lenCheck[i].fitLen) {
			if (vm[lenCheck[i].name].length != lenCheck[i].len) {
				return showMsg("“" + lenCheck[i].title + "”字符长度必须为" + lenCheck[i].len);
			}
		} else {
			if (vm[lenCheck[i].name].length > lenCheck[i].len) {
				return showMsg("“" + lenCheck[i].title + "”字符长度不能超过" + lenCheck[i].len);
			}
		}
	}
	if (verify.phoneValid(vm.customer_phone).length > 0) {
		return showMsg("寄件人电话输入错误");
	}
	//	if (verify.phoneValid(vm.receiver_phone).length > 0) {
	//		return showMsg("收件人电话输入错误");
	//	}

	submitForm();
}

function submitForm() { //创建二维码
	light.loadData("service.UpdateData", {
		params: {
			id: 1390,
			param: {
				customer_phone: vm.customer_phone,
				receiver_phone: vm.receiver_phone
			}
		}
	}, function(result) {
		//alert(JSON.stringify(result));
		if (result && result.success && result.data && result.data[0]) {
			vm.qrCode = QR.encode({
				text: result.data[0].qrcode,
				size: 300,
				border: 10,
				color: "black",
				shape: "rectangles",
				format: "image/png"
			});
			vm.submitState = "生成二维码";
		} else {
			showMsg("您尚未提交过身份证实名信息！");
		}
	}, function() {
		showMsg("生成二维码失败！");
	});
}

function autoQRCode() { //创建二维码
	light.loadData("service.UpdateData", {
		params: {
			id: 1466,
			param: {
			}
		}
	}, function(result) {
		if (result && result.success && result.data && result.data[0]) {
			vm.qrCode = QR.encode({
				text: result.data[0].qrcode,
				size: 300,
				border: 10,
				color: "black",
				shape: "rectangles",
				format: "image/png"
			});
			vm.submitState = "生成二维码";
		} else {
			showMsg("您尚未提交过身份证实名信息！");
		}
	}, function() {
		showMsg("生成二维码失败！");
	});
}

function showMsg(msg) {
	mui.alert(msg);
	vm.submitState = '生成二维码';
}