var vm;
var wv = null;
var tem_activeTab = null;
require.config({
	baseUrl: 'js/',
	paths: {
		mui: 'mui',
		light: 'light',
		avalon: 'avalon.mobile',
		md5: 'md5',
		updateHelper: 'updateHelper'
	}
});
var first = null;
require(['mui'], function($) {
	mui.init({
		swipeBack: false
	});
	mui.back = function() {
		if (!first) { //首次按键，提示‘再按一次退出应用’
			first = new Date().getTime();
			mui.toast('再按一次返回键退出应用');
			setTimeout(function() {
				first = null;
			}, 2000);
		} else {
			if (new Date().getTime() - first < 2000) {
				if (vm && vm.loginStatus == "退出登录") {
					light.loadData("user.logout", {}, function() {
						plus.runtime.quit();
					}, function() {
						plus.runtime.quit();
					}, "get"); //注销
				} else {
					plus.runtime.quit();
				}
			}
		}
	};
	require(['avalon'], function($) {
		avalon.config({
			loader: false
		});
		avalonInit();
		require(['light', 'md5', 'updateHelper'], function($) {
			light.plusready(function() {
				vm.downloadProgress = "v" + plus.runtime.version;
				vm.isAndroid = plus.os.name == 'Android';
				if (plus.storage.getItem("showGuide")) { //有值，说明已经显示过了，无需显示；
					plus.navigator.closeSplashscreen();
					plus.navigator.setFullscreen(false);
					loadPage();
				} else {
					//显示启动导航
					var guideWV = light.openWindow({
						url: 'more/guide.html',
						show: {
							aniShow: 'none'
						},
						waiting: {
							autoShow: false
						}
					});
					guideWV.addEventListener("show", function() {
						if (mui.os.ios) {
							plus.navigator.setFullscreen(true);
						}
						plus.navigator.closeSplashscreen();
					}, false);
					guideWV.addEventListener("close", function() {
						loadPage();
					}, false);
				}
			});
		});
	});
});

function loadPage() {
	wv = plus.webview.currentWebview();
	autoLogin();
	setTimeout(function() {
		updateHelper.checkUpdate(0);
	}, 5000);
}

function avalonInit() {
	vm = avalon.define({
		$id: "avaCtl",
		loginStatus: "登录",
		downloadProgress: "",
		hasNew: false,
		isAndroid: false
	});
	avalon.scan();
}
var loginAction = 0;

function autoLogin() {
	var user_account = plus.storage.getItem('username') || "";
	var password = plus.storage.getItem('password') || "";
	if (user_account && plus.storage.getItem('recordPSW') && password) {
		vm.loginStatus = "登录中...";
		loginAction++;
		var currentAction = loginAction;
		setTimeout(function() {
			if (currentAction == loginAction) {
				vm.loginStatus = "登录";
			}
		}, 15000); //15秒后无回调自动解锁
		light.loadData("edge.userLogin", {
			param: {
				username: user_account,
				password: encodeMD5(password),
				app_id: light.app_id
			}
		}, function(r) {
			if (currentAction != loginAction) {
				return;
			}
			if (r.success) {
				tem_activeTab = null;
				logSuccess();
			} else {
				vm.loginStatus = "登录";
				switch (r.status) { //0登录成功1 待审核(app提交信息)2 未通过3 未预置认证信息4 账号过期 5 账号密码错误6后台预置信息7账号未注册
					case 4:
						mui.alert('您的账号过期，需要重新注册。');
						openWin('register');
						break;
					case 5:
						mui.toast("自动登录失败，账号或密码错误!");
						break;
					case 7:
						mui.alert('账号未注册，请先注册。');
						break;
				}
			}
		}, function() { //连接失败
			if (currentAction == loginAction) {
				vm.loginStatus = "登录";
			}
		});
	}
}

function updatePush() {
	var info = plus.push.getClientInfo();
	client_id = info.clientid;
	var device_token = "";
	if (plus.os.name == "iOS") {
		device_token = info.token;
		if (device_token.length == 0) {
			// mui.alert("device_token获取失败，可能是处于调试环境");
			return;
		}
	}
	//alert(client_id);
	light.loadData("service.UpdateData", {
		params: {
			id: 1444, //更新用户推送登记信息
			param: {
				app_id: light.app_id,
				client_id: client_id,
				device_token: device_token
			}
		}
	}, function(result) {
		//alert(JSON.stringify(result));
	}, null);
}

function getCrashLog() {
	plus.io.resolveLocalFileSystemURL("/sdcard/crash/" + light.package_name + "/crash.log", function(entry) {
		var reader = null;
		entry.file(function(file) {
			reader = new plus.io.FileReader();
			reader.onloadend = function(e) {
				var o = e.target.result;
				if (o.length > 0) {
					var split = "error_content:";
					var i = o.indexOf(split);
					var device_detail = o.substr(0, i);
					var error_content = o.substr(i + split.length);
					split = "Exception";
					i = error_content.indexOf(split);
					light.loadData("service.UpdateData", {
						params: {
							id: 1456, //提交error
							param: {
								app_id: light.app_id,
								user_imsil: plus.os.name == 'Android' ? (plus.device.imsi || "-1") : "-1",
								device_detail: device_detail,
								error_content: error_content,
								error_type: error_content.substr(0, i + split.length),
								device_type: plus.os.name,
								user_terminal: plus.device.model || "-1",
								remark: ""
							}
						}
					}, function(result) {
						//alert(JSON.stringify(result));
						entry.remove(function(e) { //删除文件
							//console.log("删除成功");
						}, function(e) {
							//console.log("删除失败");
						});
					}, null);
				} else {
					entry.remove();
				}
			};
			reader.readAsText(file);
		}, function(e) {
			//console.log(e.message);
		});
	}, function(e) {
		//console.log("不存在失败日志");
	});
}

function log(activeTab) {
	if (vm.loginStatus == "退出登录") {
		mui.confirm('确定退出登录？', '提示', ["确定", "取消"], function(e) {
			if (e.index == 0) {
				light.delCookie(null, 1); //清除light开头的缓存	
				plus.storage.setItem('recordPSW', "0");
				plus.storage.removeItem('password');
				vm.loginStatus = "注销中...";
				light.loadData("user.logout", {}, function() {
					vm.loginStatus = "登录";
				}, function() {
					vm.loginStatus = "登录";
				}, "get"); //注销
			}
		});
	} else {
		tem_activeTab = activeTab;
		light.openWindow({
			url: 'more/login.html'
		});
	}
}

function logSuccess() { //登录页也有调用
	loginAction++;
	vm.loginStatus = '退出登录';
	setTimeout(function() {
		updatePush();
		if (plus.os.name == 'Android') {
			getCrashLog();
		}
	}, 2000);
	if (tem_activeTab != null) {
		enterModule(tem_activeTab);
	}
}

function encodeMD5(pw) {
	pw = light.trim(pw);
	if (pw.length > 0) {
		return pw.length == 32 ? pw : MD5(pw);
	} else {
		return "";
	}
}

function updateInfoCallback(b) {
	vm.hasNew = b;
}

function enterModule(activeTab) {
	if (vm.loginStatus == "退出登录") {
		light.openWindow({
			url: 'index.html',
			extras: {
				activeTab: activeTab
			}
		});
	} else {
		if (vm.loginStatus == "登录中...") {
			mui.toast("正在登录，请稍候再试")
		} else {
			log(activeTab);
		}
	}

}