//对日期进行格式化输出
var dateHelper = (function() {
	var now = new Date();
	var thisYear = now.getFullYear();
	var today = now.format("yyyy-MM-dd");
	
	function strToDate(str) {//ios下需要修正-号为/
		if(!str.toLowerCase().endWith("z")){
			str = str.replace(/-/g, "/");
		}	
		return new Date(str);
	}

	//返回当前日期时间
	function currentTime() {
		return now.format("yyyy-MM-dd HH:mm:ss");
	}

	//对日期时间进行简化显示
	function shortTime(time) {
		time = strToDate(time).format("yyyy-MM-dd HH:mm");
		var day = time.substr(0, 10);
		if (today == day) { //今天显示小时分钟			
			return time.substr(11, 5);
		} else {
			if (day.substr(0, 4) == thisYear) { //去年以前显示年月日
				return day.substr(5, 5);
			} else { //昨天以前显示月份日期
				return day;
			}
		}
	}

	//提供外部访问接口
	return {
		dateHelper: dateHelper,
		currentTime: currentTime,
		strToDate: strToDate,
		today: today,
		thisYear: thisYear,
		shortTime: shortTime
	}
})()