var light = function() {
	//应用基础配置
	var code_version = 'app'; //分为app和wx
	var system = "lightapp_"; //系统缓存变量标识
	var templet_id = 7;
	var app_id = 119; //内置应用程序ID号
	var version_code = 4; //同manifest的版本code
	var appStoreID = "1093696735"; //苹果商店应用ID 
	var nodejsServer = "http://fjyz.aiqy.cn:2000";
	//var nodejsServer = "http://120.39.251.43:2000";
	//var nodejsServer = "http://120.39.251.39:2000";
	var listenSms = "106"; //监听短信号码开头
	var package_name = "cn.aiqy.delivery_public";
	var hashSign = -1041668351; //apk安装包签名哈希值

	function isDefine(para) {
		if (typeof para == 'undefined' || para == "" || para == null || para == undefined) return false;
		else return true;
	}

	function zeroize(value, length) {
		if (!length) length = 2;
		value = String(value);
		for (var i = 0, zeros = ''; i < (length - value.length); i++) {
			zeros += '0';
		}
		return zeros + value;
	};

	Date.prototype.format = function(mask) {
		var d = this;
		return mask.replace(/"[^"]*"|'[^']*'|\b(?:d{1,4}|m{1,4}|yy(?:yy)?|([hHMstT])\1?|[lLZ])\b/g, function($0) {
			switch ($0) {
				case 'd':
					return d.getDate();
				case 'dd':
					return zeroize(d.getDate());
				case 'ddd':
					return ['Sun', 'Mon', 'Tue', 'Wed', 'Thr', 'Fri', 'Sat'][d.getDay()];
				case 'dddd':
					return ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'][d.getDay()];
				case 'M':
					return d.getMonth() + 1;
				case 'MM':
					return zeroize(d.getMonth() + 1);
				case 'MMM':
					return ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'][d.getMonth()];
				case 'MMMM':
					return ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'][d.getMonth()];
				case 'yy':
					return String(d.getFullYear()).substr(2);
				case 'yyyy':
					return d.getFullYear();
				case 'h':
					return d.getHours() % 12 || 12;
				case 'hh':
					return zeroize(d.getHours() % 12 || 12);
				case 'H':
					return d.getHours();
				case 'HH':
					return zeroize(d.getHours());
				case 'm':
					return d.getMinutes();
				case 'mm':
					return zeroize(d.getMinutes());
				case 's':
					return d.getSeconds();
				case 'ss':
					return zeroize(d.getSeconds());
				case 'l':
					return zeroize(d.getMilliseconds(), 3);
				case 'L':
					var m = d.getMilliseconds();
					if (m > 99) m = Math.round(m / 10);
					return zeroize(m);
				case 'tt':
					return d.getHours() < 12 ? 'am' : 'pm';
				case 'TT':
					return d.getHours() < 12 ? 'AM' : 'PM';
				case 'Z':
					return d.toUTCString().match(/[A-Z]+$/);
				default:
					return $0.substr(1, $0.length - 2);
			}
		});
	};

	String.prototype.endWith = function(str) {
		if (str == null || str == "" || this.length == 0 || str.length > this.length)
			return false;
		if (this.substring(this.length - str.length) == str)
			return true;
		else
			return false;
	}

	String.prototype.startWith = function(str) {
		if (str == null || str == "" || this.length == 0 || str.length > this.length)
			return false;
		if (this.substr(0, str.length) == str)
			return true;
		else
			return false;
	}

	function trim(o) {
		if (typeof o != 'string') {
			if (typeof o == 'number') {
				return o;
			} else
				return "";
		} else　
			return o.replace(/(^\s*)|(\s*$)/g, "");　　
	}

	function sysInfo() {
		return plus.os;
	}

	//字串或JSON写入cookies操作 
	function setCookie(objName, objValue) {
		var sto = window.localStorage;
		var s = objValue;
		if (typeof s == "object") s = JSON.stringify(objValue);
		if (sto) {
			sto.setItem(system + objName, objValue);
			return true;
		} else return false;
	}

	//读取cookies操作 
	function getCookie(objName, nvlValue, isOri) {
		var sto = window.localStorage;
		if (sto) sto = sto.getItem((isOri == null ? system : "") + objName);
		if (sto == null && nvlValue != null) return nvlValue;
		else return sto;
	}

	//删除cookie操作(_search=1时为左匹配)
	function delCookie(_obj, _search) {
		var sto = window.localStorage;
		if (!sto) return false;
		var obj = _obj;
		if (obj && typeof(obj) == "string") obj = system + obj;
		//清除批量缓存
		if (obj == null || _search == 1) {
			for (var key in sto) {
				if (obj == null && key.indexOf(system) == 0 || _search == 1 && key.indexOf(obj) == 0) sto.removeItem(key);
				if (_search == 2 && (obj == null || key.indexOf(obj) == 0)) sto.removeItem(key);
			}
		}
		//清除单个缓存
		if (typeof(obj) == "string" && _search == null) sto.removeItem(obj);
		//清除一系列缓存
		if (typeof(obj) == "array")
			for (var i = 0; i < obj.length; i++) sto.removeItem(system + obj[i]);
		return true;
	}

	function openWindow(obj) {
		if (obj.id == null) {
			obj.id = obj.url;
		}
		var wv = plus.webview.getWebviewById(obj.id);
		if (wv) {
			wv.show();
			return wv;
		}
		return mui.openWindow(obj);
	}

	function backAndReload(func) {
		plus.webview.currentWebview().opener().evalJS(func);
		mui.back();
	}

	function plusready(func, jsApiList) {
		switch (code_version) {
			case 'app':
				mui.plusReady(function() {
					func();
				}, false);
				break;
			case 'wx':
				//is_weixin();
				mui.ready(function() {
					if (jsApiList == null) {
						func();
					} else {
						wx_ready(func, jsApiList);
					}
				});
				break;
			default:
				func();
				break;
		}
	}

	function is_weixin() { //不是微信浏览器的跳转错误页面
		var ua = navigator.userAgent.toLowerCase();
		if (ua.match(/MicroMessenger/i) != "micromessenger") {
			window.location.href = errorPage + '?msg=' + encodeURIComponent('非微信浏览器禁止访问！');
		}
	}

	function wx_ready(func, jsApiList) {
		loadData("edge.GetWxSdkSign", {
			url: document.URL,
			app_id: app_id
		}, function(result) {
			if (result.success == false) { //一般情况下是appid数据库登记错误
				window.location.href = light.errorPage + '?msg=' + encodeURIComponent(result.msg);
			} else {
				wx.config({
					debug: false,
					appId: app_id,
					timestamp: result.timestamp,
					nonceStr: result.noncestr,
					signature: result.signature,
					jsApiList: jsApiList
				});
				wx.ready(function() {
					func() //不执行时应检查是否页面忘记引用微信JS
				});
				//				wx.error(function(res){
				//					alert(JSON.stringify(res));
				//				});
			}
		}, function(result) {

		});
	}

	function hideWxButton() {
		wx_ready(function() {
			wx.hideOptionMenu();
		}, ['hideOptionMenu']);
	}

	function appendIframe(list, parentWV) {
		if (parentWV == null) {
			plus.webview.currentWebview().append(list);
		} else {
			plus.webview.getWebviewById(parentWV).append(list);
		}
	}

	function removeIframe(list) {
		plus.webview.currentWebview().remove(list);
	}

	function getViewParam() {
		return plus.webview.currentWebview();
	}

	function getUrlParam(name) {
		var reg = new RegExp("[?&]" + name + "\=([^&]+)", "g");
		var matcher = reg.exec(window.location.search);
		var items = null;
		if (null != matcher) {
			try {
				items = decodeURIComponent(decodeURIComponent(matcher[1]));
			} catch (e) {
				try {
					items = decodeURIComponent(matcher[1]);
				} catch (e) {
					items = matcher[1];
				}
			}
		}
		return items;
	}

	function getCurrentPage() {
		var str = location.pathname;
		return str.substr(str.lastIndexOf("/") + 1);
	}

	function getArg() {
		var str = location.search;
		if (str != null && str.length > 0) {
			return str.substr(1, str.length - 1);
		} else {
			return "";
		}
	}

	function getReturnArg() {
		var str = getArg();
		return "?skip=" + getCurrentPage() + (str ? "&" + str : "");
	}

	function getUser() { //获取user_id，userphone之前先执行一次getUser，建议在页面载入时执行
		var user_id = getCookie("login_uid") || 0;
		var userphone = getCookie("userphone") || '';
		return {
			user_id: user_id,
			userphone: userphone
		};
	}

	function loadData(service, data, suc, err, type) {
		mui.ajax(nodejsServer + "/" + service.replace(".", "/"), {
			data: data,
			dataType: 'json', //服务器返回json格式数据
			type: type || 'post', //HTTP请求类型
			timeout: function() {
				if (plus != null) {
					return plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_CELL4G ? 15000 : 30000
				} else {
					return 15000;
				}
			}, //超时时间
			success: function(data) { //服务器返回响应
				if (data && typeof data.success != 'undefined' && !data.success && (service == 'service.GetData' || service == 'service.GetMultiLogic' || service == 'service.UpdateData')) { //session丢失且调用了含session脚本
					mui.alert("您的登录状态已失效，请重新登录");
					if (err) {
						err();
					}
				} else {
					if (suc)
						suc(data);
				}
			},
			error: function(xhr, type, errorThrown) { //异常处理
				//alert(type)
				switch (type) {
					case 'error':
						switch (xhr.status) {
							case 413:
								mui.toast("上传数据量过大"); //Request Entity Too Large
							default:
								mui.toast("调用服务异常！"); //xhr.status == 500
						}
						break;
					case 'parsererror':
						mui.toast("返回数据格式错误！"); //被重定向
						mui.alert("您的登录状态已失效，请重新登录");
						break;
					case 'timeout':
						mui.toast("访问超时！");
						break;
					case 'abort':
						if (code_version == "app") {
							if (plus.networkinfo.getCurrentType() == plus.networkinfo.CONNECTION_NONE) { //网络关闭
								mui.toast("获取数据失败，请检查网络状态！")
							} else {
								mui.toast("服务器无响应！")
							}
						} else {
							mui.toast("获取数据失败，请检查网络状态！")
						}
						break;
					default:
						if (code_version != "app" && nodejsServer != ("http://" + window.location.host)) {
							mui.toast("跨域访问服务被浏览器拒绝，请检查URL域名应为" + nodejsServer);
						}
				}
				if (err) {
					err();
				}
			}
		});
	}

	function saveLog(page, remark) { //记录日志
		var param = {
			appid: app_id,
			user_imsil: plus.os.name == 'Android' ? (plus.device.imsi || "-1") : "-1",
			visit_page: page,
			device_type: plus.os.name,
			user_terminal: plus.device.model || "-1",
			remark: remark || "访问页面"
		}
		light.loadData("service.SaveLog", {
			param: param
		}, null, null);
	}

	function pluginFun(fun, Arg, successCallback, errorCallback) {
		var B = window.plus.bridge;
		var success = typeof successCallback !== 'function' ? null : function(args) {
				successCallback(args);
			},
			fail = typeof errorCallback !== 'function' ? null : function(code) {
				errorCallback(code);
			};
		callbackID = B.callbackId(success, fail);
		return B.exec('plugintest', fun, [callbackID, Arg]);
	}
	//提供外部访问接口
	return {
		light: light,
		appStoreID: appStoreID,
		code_version: code_version,
		app_id: app_id,
		package_name: package_name,
		listenSms: listenSms,
		openWindow: openWindow,
		plusready: plusready,
		backAndReload: backAndReload,
		appendIframe: appendIframe,
		removeIframe: removeIframe,
		getViewParam: getViewParam,
		getUrlParam: getUrlParam,
		getCurrentPage: getCurrentPage,
		getArg: getArg,
		getReturnArg: getReturnArg,
		getUser: getUser,
		nodejsServer: nodejsServer,
		templet_id: templet_id,
		version_code: version_code,
		setCookie: setCookie,
		getCookie: getCookie,
		delCookie: delCookie,
		loadData: loadData,
		saveLog: saveLog,
		sysInfo: sysInfo,
		isDefine: isDefine,
		hideWxButton: hideWxButton,
		wx_ready: wx_ready,
		trim: trim,
		pluginFun: pluginFun,
		hashSign: hashSign
	}
}()