var updateHelper = (function() {
	function downloadFile(url) {
		light.pluginFun("updateApp", url, function(result) {
				//mui.alert(result[0]);
			},
			function(result) {
				mui.alert("创建下载任务失败！");
			});
	}

	function checkUpdate(updateState) { //updateState0自动，1手动，2 重新下载 ,3仅检查版本    
		if (updateState > 0) {
			plus.nativeUI.showWaiting();
		}
		if (plus.os.name == 'iOS' && light.appStoreID) { //如果是ios上架版
			return checkAppStore(light.appStoreID, updateState);
		}
		light.loadData("service.GetData", { //获取最新版本信息
				total: true,
				params: {
					id: 1087,
					param: {
						app_id: light.app_id,
						device_type: plus.os.name.toLowerCase()
					}
				}
			}, function(result) {
				plus.nativeUI.closeWaiting();
				var ignoreVersion = plus.storage.getItem("ignoreVersion");
				var o = result.data[0];
				if (o == null || o.version_code <= light.version_code) { //自动升级并且忽略版本	
					if (updateState == 1) { //手动检测提示
						mui.toast("当前已经是最新版!");
					}
					return;
				}
				if (updateState == 0 && ignoreVersion == o.version_code.toString()) { //自动升级并且忽略版本	
					return;
				}
				if (o.version_code > light.version_code) {
					updateInfoCallback(true);
					if (updateState == 3) { //仅检查版本
						return;
					}
				}
				if (o.beta) { //测试版询问
					mui.confirm(o.info, '发现新版本v' + o.version_name + '，是否升级？', ['确定', '忽略该版本'], function(e) {
						if (e.index == 0) {
							if (plus.os.name == 'Android') {
								downloadFile(o.download_url);
							} else {
								if (plus.os.name == 'iOS') {
									plus.runtime.openURL(o.download_url);
								}
							}
						} else {
							plus.storage.setItem("ignoreVersion", o.version_code.toString());
						}
					});
				} else { //正式版强制升级
					mui.alert(o.info, '发现新版本v' + o.version_name, "确定", function() {
						if (plus.os.name == 'Android') {
							downloadFile(o.download_url);
						} else {
							if (plus.os.name == 'iOS') {
								plus.runtime.openURL(o.download_url);
							}
						}
					});
				}
			},
			function() {
				plus.nativeUI.closeWaiting();
			});
	}

	function checkAppStore(appStoreID, updateState) {
		var url = "https://itunes.apple.com/lookup?id=" + appStoreID;
		mui.ajax(url, {
			data: '',
			dataType: 'string',
			type: 'get',
			success: function(result) {
				plus.nativeUI.closeWaiting();
				var res = JSON.parse(result);
				if (res.resultCount > 0) {
					var o = res.results[0];
					if (judgeVersion(plus.runtime.version.split('.'), o.version.split('.'))) {
						if (updateState == 3) { //仅检查版本
							updateInfoCallback(true);
						} else {
							mui.confirm(o.releaseNotes, '发现新版本' + o.version + '，是否升级？', ['确定', '以后再说'], function(e) {
								if (e.index == 0) {
									plus.runtime.openURL(o.trackViewUrl);
								}
							});
						}
					} else {
						if (updateState == 1) {
							mui.toast("当前已经是最新版!");
						}
					}
				} else { //首发版本（未上架）
					if (updateState == 1) {
						mui.toast("当前已经是最新版!");
					}
				}
			},
			error: function() {
				if (updateState == 1) {
					plus.nativeUI.closeWaiting();
					mui.toast("检查更新信息失败");
				}
			}
		});
	}

	function judgeVersion(oldVersionSplit, newVersionSplit) { //版本比较
		splitLength = Math.max(oldVersionSplit.length, newVersionSplit.length);
		if (oldVersionSplit.length != newVersionSplit.length) { //长度不相等的必须补充
			if (oldVersionSplit.length > newVersionSplit.length) {
				for (var i = newVersionSplit.length; i < splitLength; i++) {
					newVersionSplit.push(0);
				}
			} else {
				for (var i = oldVersionSplit.length; i < splitLength; i++) {
					oldVersionSplit.push(0);
				}
			}
		}
		for (var i = 0; i < splitLength; i++) { //版本比较
			if (newVersionSplit[i] != oldVersionSplit[i]) {
				return newVersionSplit[i] > oldVersionSplit[i];
			}
		}
		return false;
	}
	//提供外部访问接口
	return {
		updateHelper: updateHelper,
		checkUpdate: checkUpdate
	}
})()