var vm;
var wv;
require.config({
	baseUrl: '../js/',
	paths: {
		mui: 'mui',
		light: 'light',
		avalon: 'avalon.mobile',
		md5: 'md5'
	}
});

require(['mui'], function($) {
	mui.init({
		swipeBack: false
	});
	require(['avalon'], function($) {
		avalon.config({
			loader: false
		});
		avalonInit();
		require(['light', 'md5'], function($) {
			light.plusready(function() {
				loadPage();
			});
		});
	});
});

function loadPage() {
	wv = plus.webview.currentWebview();
	vm.downloadProgress = "v" + plus.runtime.version;
	vm.username = plus.storage.getItem('username') || "";
	vm.password = plus.storage.getItem('password') || "";
	vm.recordPSW = plus.storage.getItem('recordPSW') || false;
	if (vm.password.length == 0) {
		vm.hidPswBtn = false;
	}
	mui(".mui-input-row").on('tap', '.mui-icon-clear', function() { //捕获清空按钮事件,主动重置avalon变量
		var o = event.currentTarget.children;
		for (var i in o) {
			if (o[i].tagName == "INPUT" && o[i].id) {
				vm[o[i].id] = "";
				break;
			}
		}
	});
	mui(".mui-password").on('click', '.mui-icon-eye', function() { //捕获可见隐藏事件,主动还原光标
		mui(".mui-input-password")[0].focus();
	});
	manualLogin();
}

function switchRecordPSW() {
	if (vm.recordPSW) {
		plus.storage.removeItem('password');
	}
	vm.recordPSW = !vm.recordPSW;
	plus.storage.setItem('recordPSW', vm.recordPSW ? "1" : "0");
}

function avalonInit() {
	vm = avalon.define({
		$id: "avaCtl",
		username: "",
		password: "",
		recordPSW: false,
		hidPswBtn: true,
		loginStatus: "登录",
		downloadProgress: ""
	});    
	avalon.scan();
	vm.$watch("password", function(newValue, oldValue) {
		if (newValue.length == 0) {
			mui(".mui-input-password")[0].value = "";
			if (vm.hidPswBtn) {
				vm.hidPswBtn = false;
				mui(".mui-input-password")[0].focus();
			}
		}
	});
}

function hidePsw() {
	setTimeout(function() {
		if (document.activeElement.className != "mui-input-password") {
			if (mui(".mui-input-password")[0].type == "text") {
				mui.trigger(mui(".mui-icon-eye")[0], 'tap');
			}
			if (vm.password.length > 0) {
				vm.hidPswBtn = true;
			}
		}
	}, 500);
}


function manualLogin() {
	if (plus.storage.getItem('recordPSW') && vm.username && vm.password) { //如果记住密码，自动登陆
		encodeMD5(vm.password);
		doLogin(false);
	} else {
		vm.recordPSW = false;
		plus.storage.setItem('recordPSW', "0");
	}
}
var loginAction = 0;

function doLogin(loginType) {
	if (loginType) { //手动登录
		if (vm.username.length == 0) {
			mui.toast("用户名不能为空");
			return;
		}
		if (vm.password.length == 0) {
			mui.toast("密码不能为空");
			return;
		}
	}
	vm.loginStatus = "登录中...";
	loginAction++;
	var currentAction = loginAction;
	setTimeout(function() {
		if (currentAction == loginAction) {
			vm.loginStatus = "登录";
		}
	}, 15000); //15秒后无回调自动解锁
	light.loadData("edge.userLogin", {
		param: {
			username: vm.username,
			password: encodeMD5(vm.password),
			app_id: light.app_id
		}
	}, function(r) {
		if (currentAction != loginAction) {
			return;
		}
		if (r.status < 4) {
			if (vm.recordPSW) { /*如果选择记录登录信息，将个人信息本地存储（使用cookie）*/
				plus.storage.setItem('username', vm.username);
				plus.storage.setItem('password', encodeMD5(vm.password));
				plus.storage.setItem('recordPSW', "1");
			} else {
				plus.storage.setItem('recordPSW', "0");
			}
		}
		if (r.success) {
			wv.opener().evalJS("logSuccess()");
			mui.back();
		} else {
			vm.loginStatus = "登录";
			/*if (loginType) {
				mui.alert(r.msg);
			} else {
				mui.toast("自动登录失败，" + r.msg);
			}
				alert(r.status);*/
			switch (r.status) { //0登录成功1 待审核(app提交信息)2 未通过3 未预置认证信息4 账号过期 5 账号密码错误6后台预置信息7账号未注册
				case 1:
					mui.confirm('您提交的实名认证正在审核中，请联系公司管理员。', '提示', ['确定', '修改信息'], function(e) {
						if (e.index == 1) {
							light.openWindow({
								url: '../manage/certify.html',
								extras: {
									hasLogin: false,
									user_account: vm.username
								}
							});
						}
					});
					break;
				case 2:
					mui.confirm('您提交的实名认证审核未通过，请联系公司管理员。', '提示', ['确定', '修改信息'], function(e) {
						if (e.index == 1) {
							light.openWindow({
								url: '../manage/certify.html',
								extras: {
									hasLogin: false,
									user_account: vm.username
								}
							});
						}
					});
					break;
				case 3:
				case 6:
					mui.alert('请完善您的实名认证信息。');
					light.openWindow({
						url: '../manage/certify.html',
						extras: {
							hasLogin: false,
							user_account: vm.username
						}
					});
					break;
				case 4:
					mui.alert('您的账号过期，需要重新注册。');
					openWin('register');
					break;
				case 5:
					if (loginType) {
						mui.alert('账号或密码错误!');
					} else {
						mui.toast("自动登录失败，账号或密码错误!");
					}
					break;
				case 7:
					mui.alert('账号未注册，请先注册。');
					break;
			}
		}
	}, function() { //连接失败
		if (currentAction == loginAction) {
			vm.loginStatus = "登录";
		}
	});
}

function openWin(pageType) {
	light.openWindow({
		url: 'register.html',
		extras: {
			pageType: pageType,
			phone: vm.username
		}
	});
}

function encodeMD5(pw) {
	pw = light.trim(pw);
	if (pw.length > 0) {
		return pw.length == 32 ? pw : MD5(pw);
	} else {
		return "";
	}
}